<?xml version="1.0" encoding="UTF-8"?>

<!--
 *
 * This help file was generated from nan_nhist.sci using help_from_sci().
 *
 -->

<refentry version="5.0-subset Scilab" xml:id="nan_nhist" xml:lang="en"
          xmlns="http://docbook.org/ns/docbook"
          xmlns:xlink="http://www.w3.org/1999/xlink"
          xmlns:svg="http://www.w3.org/2000/svg"
          xmlns:ns3="http://www.w3.org/1999/xhtml"
          xmlns:mml="http://www.w3.org/1998/Math/MathML"
          xmlns:scilab="http://www.scilab.org"
          xmlns:db="http://docbook.org/ns/docbook">

  <refnamediv>
    <refname>nan_nhist</refname>
    <refpurpose>Histogram</refpurpose>
  </refnamediv>


<refsynopsisdiv>
   <title>Calling Sequence</title>
   <synopsis>
   [theText, rawN, x] = nan_nhist(cellValues, 'parameter', value, ...)
   t = nan_nhist(Y)
   [t, N, X]= nan_nhist(...)
   nan_nhist(Y,'PropertyName', . . . )
   nan_nhist(Y,'PropertyName',PropertyValue, . . . )
   </synopsis>
</refsynopsisdiv>

<refsection>
   <title>Parameters</title>
   <variablelist>
   <varlistentry><term>Histogram and bin settings:</term>
      <listitem><para> </para></listitem></varlistentry>
   <varlistentry><term>'binfactor':</term>
      <listitem><para> Effects the number of bins used. A larger number</para></listitem></varlistentry>
   <varlistentry><term>'samebins':</term>
      <listitem><para> this will make all the bins align with each other</para></listitem></varlistentry>
   <varlistentry><term>'minbins':</term>
      <listitem><para> The minimum number of bins allowed for each graph</para></listitem></varlistentry>
   <varlistentry><term>'maxbins':</term>
      <listitem><para> The maximum number of bins allowed for each graph</para></listitem></varlistentry>
   <varlistentry><term>'stdtimes':</term>
      <listitem><para> Number of times the standard deviation to set the</para></listitem></varlistentry>
   <varlistentry><term>'minx':</term>
      <listitem><para> crop the axis and histogram on the left. 'xmin'</para></listitem></varlistentry>
   <varlistentry><term>'maxx':</term>
      <listitem><para> crop the axis and histogram on the right. 'xmax'</para></listitem></varlistentry>
   <varlistentry><term>'proportion':</term>
      <listitem><para> Plot proportion of total points on the y axis</para></listitem></varlistentry>
   <varlistentry><term>'pdf':</term>
      <listitem><para> Plot the pdf on the y axis</para></listitem></varlistentry>
   <varlistentry><term>'numbers':</term>
      <listitem><para> Plot the raw numbers on the graph. 'number'</para></listitem></varlistentry>
   <varlistentry><term>'smooth':</term>
      <listitem><para> Plot a smooth line instead of the step function.</para></listitem></varlistentry>
   <varlistentry><term>Text related parameters:</term>
      <listitem><para> </para></listitem></varlistentry>
   <varlistentry><term>'titles','legend':</term>
      <listitem><para> A cell array with strings to put in the legend or</para></listitem></varlistentry>
   <varlistentry><term>'nolengend':</term>
      <listitem><para> In case you pass a struct, you may force a legend</para></listitem></varlistentry>
   <varlistentry><term>'text':</term>
      <listitem><para> Outputs all numbers to text, even ones that are</para></listitem></varlistentry>
   <varlistentry><term>'decimalplaces':</term>
      <listitem><para> Number of decimal places numbers will be output</para></listitem></varlistentry>
   <varlistentry><term>'npoints':</term>
      <listitem><para> this will add (number of points) to the legend or</para></listitem></varlistentry>
   <varlistentry><term>'xlabel':</term>
      <listitem><para> Label of the lowest X axis</para></listitem></varlistentry>
   <varlistentry><term>'ylabel':</term>
      <listitem><para> Label of the Y axis, note that the ylabel default</para></listitem></varlistentry>
   <varlistentry><term>'fsize':</term>
      <listitem><para> Font size, default 12. 'fontsize'</para></listitem></varlistentry>
   <varlistentry><term>'location':</term>
      <listitem><para> Sets the location of the legend,</para></listitem></varlistentry>
   <varlistentry><term>example:</term>
      <listitem><para>NorthOutside. 'legendlocation'</para></listitem></varlistentry>
   <varlistentry><term>Peripheral elements settings:</term>
      <listitem><para> </para></listitem></varlistentry>
   <varlistentry><term>'median':</term>
      <listitem><para> This will plot a stem plot of the median</para></listitem></varlistentry>
   <varlistentry><term>'mode':</term>
      <listitem><para> This will plot a stem plot of the mode</para></listitem></varlistentry>
   <varlistentry><term>'serror':</term>
      <listitem><para> Will put the mean and 'standard error' bars above</para></listitem></varlistentry>
   <varlistentry><term>'noerror':</term>
      <listitem><para> Will remove the mean and standard deviation error</para></listitem></varlistentry>
   <varlistentry><term>'linewidth':</term>
      <listitem><para> Sets the width of the lines for all the graphs</para></listitem></varlistentry>
   <varlistentry><term>'color':</term>
      <listitem><para> Sets the colormap to decide the colors of the</para></listitem></varlistentry>
   <varlistentry><term>General Figure Settings:</term>
      <listitem><para> </para></listitem></varlistentry>
   <varlistentry><term>'separate':</term>
      <listitem><para> Plot each histogram separately, also use normal</para></listitem></varlistentry>
   <varlistentry><term>'newfig':</term>
      <listitem><para> Will make a new figure to plot it in. When using</para></listitem></varlistentry>
   <varlistentry><term>'eps':</term>
      <listitem><para> EPS file name of the generated plot to save. It</para></listitem></varlistentry>
   </variablelist>
</refsection>

<refsection>
   <title>Description</title>
   <para>
   </para>
   <para>
t = nhist(Y) bins the elements of Y into equally spaced containers
and returns a string with information about the distributions.
If Y is a cell array or a list nhist will make graph the
binned (discrete) probability density function of each data
set for comparison on the same graph. It will return A cell
array or structure which includes a string for each set of
data.
   </para>
   <para>
[t, N, X]= nhist(...) also returns the number of items in each bin, N,
and the locations of the left edges of each bin. If Y is a
cell array or structure then the output is in the same form.
   </para>
   <para>
__________________________________________________________________________
   </para>
   <para>
Summary of what function does:
1) Automatically sets the number and range of the bins to be appropriate
for the data.
   </para>
   <para>
2) Compares multiple sets of data elegantly on one or more plots, with
legend or titles. It also graphs the mean and standard deviations.
It can also plot the median and mode.
   </para>
   <para>
3) Outputs text with the usefull statistics for each distribution.
   </para>
   <para>
4) Allows for changing many more parameters
   </para>
   <para>
Highlighted features (see below for details)
   </para>
   <para>
'separate' to plot each set on its own axis, but with the same bounds
   </para>
   <para>
'binfactor' change the number of bins used, larger value =more bins
   </para>
   <para>
'samebins' force all bins to be the same for all plots
   </para>
   <para>
'legend' add a legend in the graph (default for structs)
   </para>
   <para>
'noerror' remove the mean and std plot from the graph
   </para>
   <para>
'median' add the median of the data to the graph
   </para>
   <para>
'text' return many details about each graph even if not plotted
   </para>
   <para>
Optional Properties
   </para>
   <para>
Note: Alternative names to call the properties are listed at the end of each
entry.
   </para>
   <para>
The bin width is defined in the following way
Disclaimer: this function is specialized to compare data with comparable
standard deviations and means, but greatly varying numbers of points.
   </para>
   <para>
Scotts Choice used for this function is a theoretically ideal way of
choosing the number of bins. Of course the theory is general and so not
rigorous, but I feel it does a good job.
(bin width) = 3.5*std(data points)/(number of points)^(1/3);
   </para>
   <para>
I did not follow it exactly though, restricting smaller bin sizes to be
divisible by the larger bin sizes. In this way the different conditions
can be accurately compared to each other.
   </para>
   <para>
The bin width is further adulterated by user parameter 'binFactor'
(new bin width) = (old bin width) / (binFactor);
it allows the user to make the bins larger or smaller to their tastes.
Larger binFactor means more bins. 1 is the default
   </para>
   <para>
Source: http://en.wikipedia.org/wiki/Histogram#Number_of_bins_and_width
   </para>
   <para>
Default function behaviour
   </para>
   <para>
If you pass it a structure, the field names will become the legend. All
of the data outputted will be in structure form with the same field
names. If you pass a cell array, then the output will be in cell form. If
you pass an array or vector then the data is outputted as a string and
two arrays.
   </para>
   <para>
   </para>
   <para>
standard deviation will be plotted as a default, unless one puts in the
'serror' paramter which will plot the standard error = std/sqrt(N)
   </para>
   <para>
There is no maximum or minimum X values.
   </para>
   <para>
minBins=10; The minimum number of bins for the histogram
   </para>
   <para>
maxBins=100;The maximum number of bins for a histogram
   </para>
   <para>
AxisFontSize = 12; 'fsize' the fontsize of everything.
   </para>
   <para>
The number of data points is not displayed
   </para>
   <para>
The lines in the histograms are black
   </para>
   <para>
faceColor = [.7 .7 .7]; The face of the histogram is gray.
   </para>
   <para>
It will plot inside a figure, unless 'newfig' is passed then it will make
a new figure. It will take over and refit all axes.
   </para>
   <para>
linewidth=2; The width of the lines in the errobars and the histogram
   </para>
   <para>
stdTimes=4; The axes will be cutoff at a maximum of 4 times the standard
deviation from the mean.
Different data sets will be plotted with a different number of bins.
   </para>
   <para>
Acknowledgments
   </para>
   <para>
Thank you to the AP-Lab at Boston University for funding me while I
developed this function. Thank you to the AP-Lab, Avi and Eli for help
with designing and testing it.
   </para>
   <para>
</para>
</refsection>

<refsection>
   <title>Examples</title>
   <programlisting role="example"><![CDATA[

A=list(rand(1,10^5,'normal'),rand(10^3,1,'normal')+1);
nan_nhist(A);
nan_nhist(A,'legend',['u=0','u=1']);
nan_nhist(A,'legend',['u=0','u=1'],'separate');
nan_nhist(A,'color','summer')
nan_nhist(A,'color',[.3 .8 .3],'separate')
nan_nhist(A,'binfactor',4)
nan_nhist(A,'samebins')
nan_nhist(A,'median','noerror')


// example #1: variations around an histogram of a gaussian random sample
d=rand(1,10000,'normal');
clf();nan_nhist(d,'proportion')
clf();nan_nhist(d)
clf();nan_nhist(d,'legend','rand(1,10000,''normal'')','color',[1 0 0],'proportion')

//example #2: histogram of a binomial (B(6,0.5)) random sample
d = grand(1000,1,"bin", 6, 0.5);
clf()
subplot(2,1,1)
nan_nhist(d,'proportion','legend',"normalized histogram")
subplot(2,1,2)
nan_nhist(d,'legend',"non normalized histogram")

// example #3: histogram of an exponential random sample
lambda = 2;
X = grand(100000,1,"exp", 1/lambda);
Xmax = max(X);
clf()
nan_nhist(X,'pdf','minx',0,'maxx',max(Xmax));
x = linspace(0,max(Xmax),100)';
plot2d(x,lambda*exp(-lambda*x),strf="000",style=5)
legends(["exponential random sample histogram" "exact density curve"],[1,5],opt="ur");

   ]]></programlisting>
</refsection>

<refsection>
   <title>Authors</title>
   <simplelist type="vert">
   <member>Jonathan Lansey April 2010,</member>
   <member>H. Nahrstaedt - 2011</member>
   </simplelist>
</refsection>
</refentry>
